'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _visitors = require('./visitors');

var _util = require('./util');

var insertEntries = function insertEntries(entries) {
  return entries.forEach(function (_ref) {
    var identifier = _ref.identifier,
        path = _ref.path,
        props = _ref.props;

    (0, _util.insertAfterPath)(path, (0, _util.createPropertyExpression)(identifier, props));
  });
};

var plugin = function plugin() {
  return {
    pre: function pre() {
      this.store = new _util.Store();
    },

    visitor: {
      Program: function Program(programPath) {
        programPath.traverse(_visitors.importVisitor, this.store);

        if (!this.store.hasImport) return;

        programPath.traverse(_visitors.entryVisitor, this.store);
        programPath.traverse(_visitors.propVisitor, this.store);

        insertEntries(this.store.getEntries());
      }
    }
  };
};

exports.default = plugin;