'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createPropertyExpression = function createPropertyExpression(identifier, props) {
  var entries = _lodash2.default.uniq(props).sort().map(function (prop) {
    return t.stringLiteral(prop);
  });

  var left = t.memberExpression(t.identifier(identifier), t.identifier('handledProps'));
  var right = t.arrayExpression(entries);

  return t.expressionStatement(t.assignmentExpression('=', left, right));
};

exports.default = createPropertyExpression;