'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _getBody = require('./getBody');

var _getBody2 = _interopRequireDefault(_getBody);

var _hasReturnStatement = require('./hasReturnStatement');

var _hasReturnStatement2 = _interopRequireDefault(_hasReturnStatement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var getRenderMethod = function getRenderMethod(path) {
  return (0, _getBody2.default)(path).find(function (member) {
    return t.isClassMethod(member) && t.isIdentifier(member.key, { name: 'render' });
  });
};

var hasSuperClass = function hasSuperClass(_ref) {
  var superClass = _ref.node.superClass;
  return !!superClass;
};

var hasValidRenderMethod = function hasValidRenderMethod(renderMethod) {
  return !!renderMethod && (0, _hasReturnStatement2.default)(renderMethod);
};

var isClass = function isClass(path) {
  return t.isClassDeclaration(path) || t.isClassExpression(path);
};

var isReactClass = function isReactClass(path) {
  return isClass(path) && hasSuperClass(path) && hasValidRenderMethod(getRenderMethod(path));
};

exports.default = isReactClass;